/*
* Math library
*
* Copyright (C) 2016 Intel Corporation. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   * Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in
*     the documentation and/or other materials provided with the
*     distribution.
*   * Neither the name of Intel Corporation nor the names of its
*     contributors may be used to endorse or promote products derived
*     from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*
* Author Name <jingwei.zhang@intel.com>
*   History:
*   03-14-2016 Initial version. numerics svn rev. 12864
*/
	.file "trig_pi_bits.c"
	.section .rodata, "a"
	.align 8
	.align 8
	.globl __four_over_pi
__four_over_pi:
	.long	0x00000000,0x00000000
	.long	0x00000000,0x00000000
	.long	0xdb939105,0x0028be60
	.long	0xf47d4d37,0x4a7f09d5
	.long	0x664f10e4,0x7036d8a5
	.long	0xeaf7aef1,0x107f9458
	.long	0x8e909374,0x586dc91b
	.long	0xba827464,0xb801924b
	.long	0xc72c4a69,0x873f877a
	.long	0x7d4baed1,0xcfba208d
	.long	0x09ad17df,0x213a671c
	.long	0x8e60d4ce,0x904e6475
	.long	0xe2ef7e4a,0x7d272117
	.long	0xfff78166,0x0ec7fe25
	.long	0x62d6829b,0x03fbcbc4
	.long	0xb3c9f2c2,0x47db4d9f
	.long	0xd9a797fa,0x6dd3d18f
	.long	0xb1faf97c,0x8b5d49ee
	.long	0x7de294a4,0x5ecf41ce
	.long	0xec47e357,0xba9afed7
	.long	0x11bf1eda,0x421580cc
	.long	0x0826bd0d,0xeafc33ef
	.long	0x5857b986,0x876a78e4
	.long	0x57c5281a,0xc2196661
	.long	0x20135cc9,0x10237ff6
	.long	0x55b29cea,0xcc418185
	.long	0xf0231ad1,0x3258389e
	.long	0xf3773a02,0xf10670d9
	.long	0x1da2e587,0x4aa0d671
	.long	0x3455c641,0x29b76bd1
	.long	0xc14fdf8c,0x4fa97fc1
	.long	0x93e60c9f,0xfa0cb0b7
	.long	0xbbdac797,0x6ef0cf49
	.long	0xcd72bc9f,0xbe27ce87
	.long	0x641f1f09,0xc761fc48
	.long	0x5dcb4c10,0x1abe9bb5
	.long	0x2d674670,0xcec57185
	.long	0x534b1740,0xf0b12b50
	.long	0x8b5c78e6,0x03119f61
	.long	0x8cdf34ad,0xb1a6c018
	.long	0x554dfd8f,0x25e9ed35
	.long	0xff1d934a,0xb5c60428
	.long	0xdc3e1f18,0xa7592af5
	.long	0xc545d592,0xd5ec1eb9
	.long	0xce2129f2,0x7036758e
	.long	0xb588d516,0xc8c91de2
	.long	0xc2bc77f3,0xae47c006
	.long	0xda879998,0x867fcc67
	.long	0xeb361fdf,0x55e651fe
	.long	0x7a0c982f,0xadd948a2
	.long	0xc24d9b35,0xf9b3713b
	.long	0x85b78ed6,0x0fd775f7
	.long	0x08b4ba21,0x24a6f78a
	.long	0x8cb2b185,0x8a135638
	.long	0x78143005,0xb8c232df
	.long	0xf8060d04,0xe9c77cd6
	.long	0xc05220d6,0xcb9884a0
	.long	0x2b7cba47,0xe3bd5fec
	.long	0xd9c43637,0x90d29234
	.long	0xb3985aa9,0x6a9097eb
	.long	0x74fca981,0x0a02ad26
	.long	0xf0a8e20f,0x9fddd720
	.long	0x96a32bef,0x185e1ce2
	.long	0x8b72effd,0x75dbd8e9
	.long	0xf0499172,0x3be06359
	.long	0xb4aa0a23,0x954db672
	.long	0x44850981,0x58709df2
	.long	0x16711131,0x26d184b1
	.long	0x7cc5c02b,0x72246c93
	.long	0x4a44357f,0x50f53952
	.long	0x2507bbb3,0x7f2f8033
	.long	0xe03c7b30,0x9c3d4f84
	.long	0x31e50164,0xf9ecca3e
	.long	0xc24bbcd1,0xcf9c706c
	.long	0x1ec82ae7,0x42e704a2
	.long	0x91cbcc9e,0xed4bb0a4
	.long	0x29dc87f9,0xdb554324
	.long	0x52859e78,0xdae5b2cc
	.long	0xfd25e53a,0x9e506277
	.long	0xcc665afb,0x2139b8a5
	.long	0xc3bf6eed,0x620d97d7
	.long	0x19d09c9c,0x26921b29
	.long	0x0567c279,0x4c97636e
	.long	0x4e5d3dc7,0x6f094c63
	.long	0x035a0212,0x014c0043
	.long	0x2a91c0b9,0xd63b8b24
	.long	0x699f7ddc,0xdd0935af
	.long	0xa7e9a523,0x921bbbc5
	.long	0x54f47c82,0xbda46d14
	.long	0x1f92fd5a,0xb3cce608
	.long	0xb740d750,0x18ec97cf
	.long	0x54957019,0x1fe2614a
	.long	0x4c920c9d,0x0dc4361b
	.long	0x539b9511,0x5316f51c
	.long	0x7d4ab559,0x704242da
	.long	0xd4011776,0x852741c9
	.long	0xba85fe61,0xceed315d
	.long	0x89c74a5a,0xdf5ad26e
	.long	0x95052b5a,0x65ab3331
	.long	0x62141c8b,0xb8a42276
	.long	0x01dddc0c,0x2fa90125
	.long	0x2a1c7a92,0x3cc9ff00
	.long	0x1920f765,0x70998f78
	.long	0x6510e321,0xe5cfe8ff
	.long	0x674e64a3,0x8377904c
	.long	0xc5cef7c2,0x1c3779ed
	.long	0x201724e0,0x0acdc568
	.long	0x363a03eb,0x16a48444
	.long	0xf6c3e40e,0xe01b12ff
	.long	0x6958aef2,0x1d861645
	.long	0xef500401,0xd86e6271
	.long	0x527dadba,0x3cb489dd
	.long	0x85028bc9,0xeec8b6ea
	.long	0x0ccec246,0xa25da0d9
	.long	0x9470a8c7,0xa503aa8e
	.long	0x89971370,0x6bbb6bc4
	.long	0x65d5b020,0x9b671e8b
	.long	0x0263100a,0xcfc0fdbc
	.long	0xed0e4548,0xe64c5b41
	.long	0x3124bd52,0x0316f0f6
	.long	0x93b34de9,0xeb71a972
	.long	0x24aada10,0xcdaa79a5
	.long	0x7be31d94,0xb77798c6
	.long	0xff2ae86b,0xa2da0df6
	.long	0x6b8036be,0x8c4577e8
	.long	0x2dc17b4c,0xc3199359
	.long	0x95cebfd1,0x194a6fd5
	.long	0xef9d77e4,0xee7e5abc
	.long	0xfda31985,0xca0c202a
	.long	0xbe877936,0x72c10188
	.long	0xc6d5c273,0x692ccf63
	.long	0xa92f84ed,0x4dba5093
	.long	0xbc2a1953,0x48ccc6aa
	.long	0xcfc2f35e,0xe9707483
	.long	0xc122dedc,0x16ddbe48
	.long	0xb1b89b9b,0x85e254e9
	.long	0x12a6edf6,0xc03afbd6
	.long	0xb3f3dd87,0xb12e99aa
	.long	0x6c706663,0x40b44b7c
	.long	0x9221a817,0x1deb70f6
	.long	0x8bfc2b26,0x7dfd2031
	.long	0x0fdb77b4,0xbb376f17
	.long	0xb6ca8e89,0x07f1e42d
	.long	0x24d4eb41,0x68e6abc0
	.long	0x4a5fa012,0x15edad0b
	.long	0xaa9da856,0xe9c1f683
	.long	0x8b6df73f,0x5eca8485
	.long	0xe27f6fa2,0x797ebfb6
	.long	0x2a419c20,0x5b1db93f
	.long	0x7fe1ff41,0x0f855ba1
	.long	0xd861860a,0xcf8a0cd9
	.long	0xf9ecdb9b,0xbaaf536b
	.long	0x56efcc52,0x63ce59e5
	.long	0xcc10cb71,0x35e105b7
	.long	0x9c326e32,0xcd584973
	.long	0xe8802939,0xcc3f5b2f
	.long	0x5691dbc8,0x1b016837
	.long	0x172e5258,0x748498a1
	.long	0xc054a64d,0x5c38159a
	.long	0x47b13c4c,0xd5542df5
	.long	0x0c176a4b,0xd7db84f9
	.long	0x4d8ca869,0xa170ec87
	.long	0x7a887dc5,0x2dc2352c
	.long	0xffc9e000,0xb91a63dd
	.long	0x683353e6,0xc30b5023
	.long	0xacc2974b,0x694834e8
	.long	0xf684742f,0xd0be6d32
	.long	0xef45eae0,0x9f7076e6
	.long	0x8205d54b,0x68b2971a
	.long	0x051fe181,0x954009fc
	.long	0x235065b7,0xf85902c5
	.long	0x76ad895a,0xafa1cabf
	.long	0xbcc167af,0xcd225eff
	.long	0x2a0a9296,0xee53da9a
	.long	0x0b6616b5,0xb113ef3e
	.long	0x5343698e,0xe571fd23
	.long	0x2c4fc525,0x8817d5e9
	.long	0x3321b75c,0x4e200048
	.long	0x582fc459,0x6db7b27d
	.long	0x6b2c2334,0x535ac1c0
	.long	0x5443bec7,0x302c9215
	.long	0xc1a8cd50,0xb0dca54e
	.long	0xb311783e,0x301ef701
	.long	0xb5907cfa,0x8a53b232
	.long	0x1926cc6f,0x37991f36
	.long	0x35161df1,0xb670e5e9
	.long	0xbc0f0eae,0x78da44f6
	.long	0xdd557d6f,0x91861197
	.long	0x974bab3b,0x74b1a49b
	.long	0x8721f118,0x5103908f
	.long	0xf5b9f29f,0x7a7f4a7c
	.long	0xf1780223,0x088d645b
	.long	0x9bb1bf6c,0x75fff89a
	.long	0x175f2cab,0x304224dd
	.long	0x5edc8f9a,0x5ae75bb3
	.long	0xfdf7dcca,0x8471aa73
	.long	0x402dc36c,0x6eb26d54
	.long	0x181f7962,0xb8892e9d
	.long	0x43430620,0xb61d0b05
	.long	0x8a405d9e,0x65199f85
	.long	0x7bd1558d,0xa7efbf7f
	.long	0x7b2e6ea2,0x9fb644f6
	.long	0xea0c70db,0xff25f109
	.long	0x15aa362d,0xbc4db165
	.long	0x33cb6244,0x6a2d03b3
	.long	0x558b38f3,0x8d15dbe2
	.long	0xaa979ae7,0xa66e4835
	.long	0xc45282ff,0x0a8fb317
	.long	0x4ee38b21,0x7efd385b
	.long	0x6a6d3f34,0xb8a1353a
	.long	0x4b984e4b,0x7bbbf24d
	.long	0x3646c2bf,0xd1084e32
	.long	0xf6070be1,0x205a92be
	.long	0x53b30895,0x2d14e326
	.long	0xb1b02586,0x37154ab5
	.long	0x99255a58,0x42ee1c06
	.long	0x8fc3c45f,0x1689bb94
	.long	0x72ff0b6f,0xc46d7d3d
	.long	0x33177a18,0x0d3baf0d
	.long	0x99fbcce4,0x17b766e3
	.long	0xd6186f15,0xae05f266
	.long	0x440fb612,0xf871a0d4
	.long	0x0b68462b,0x1c777747
	.long	0xfcd6661e,0xd18b0875
	.long	0xbea193ff,0xb6701527
	.long	0x794d88a2,0x0195ab9e
	.long	0x24d9eaba,0x48ab4e37
	.long	0xa6f9f2a9,0x154e09a0
	.long	0xe643b5ea,0x03546c4c
	.long	0x2c9969e2,0x52015a7c
	.long	0x0db47e6c,0x1fe5d322
	.long	0x9ec873e6,0xe48852a0
	.long	0x51f70e9d,0x3727d015
	.long	0xf7e77f97,0x3850bad9
	.long	0xdedeab2e,0xf517a919
	.long	0xe20ad56e,0xa8bd9548
	.long	0x618a8860,0x90421b96
	.long	0xe27527b9,0xd1ce79b8
	.long	0x55bff283,0x503ed27a
	.long	0x4afea531,0xc7229671
	.long	0x43eb96b6,0x7074f3f1
	.long	0x90e14ee1,0xe1b151d8
	.long	0x21d8441e,0x88651e4b
	.long	0x2004afd0,0xd30a868b
	.long	0x4f1e3931,0xe409a222
	.long	0x708eb13a,0x2a1ef6f9
	.long	0xfdefe483,0xbd09a299
	.long	0x64cf42df,0x4ae8d96c
	.long	0x18f749f7,0x2f771469
	.long	0x26a54a6a,0x785a4665
	.long	0x3b424827,0x0a339a2d
	.long	0x98e09c08,0xd132a613
	.long	0x43e3bd69,0xdf1f8cae
	.long	0x3c484aa7,0xf9d58502
	.long	0xd446696a,0x6d535f9b
	.long	0xe0987765,0xfe6d75b7
	.long	0xceb12868,0x808d85a7
	.long	0x9ea34e6a,0xa0db7b5c
	.long	0x9ad6c9d1,0x6e20970c
	.long	0xc034957d,0xbb4d001d
	.long	0x601c7838,0x3f135640
	.long	0x7cd92a3c,0x4fe26ca5
	.long	0x3f133aac,0x6ba9d2ce
	.type	__four_over_pi,@object
	.size	__four_over_pi,2104
	.data
	.section .note.GNU-stack, ""
# End
